import { type MouseEvent, type SyntheticEvent } from 'react';
import { LocationDescriptor } from 'farce';
import { Match, Router } from './typeUtils';
export type LinkPropsCommon = {
    to: LocationDescriptor;
    exact?: boolean;
    target?: React.HTMLAttributeAnchorTarget;
    match?: Match;
    router?: Router;
};
export type LinkPropsNodeChild = LinkPropsCommon & React.ComponentPropsWithoutRef<'a'> & {
    activeClassName?: string;
    activeStyle?: Record<string, unknown>;
    children?: React.ReactNode;
};
export interface LinkInjectedProps {
    href: string;
    onClick: (event: SyntheticEvent) => void;
    ref?: React.Ref<any> | null;
}
export type LinkPropsWithFunctionChild = LinkPropsCommon & {
    activeClassName?: never;
    activeStyle?: never;
    onClick?: (event: MouseEvent) => void;
    children: (props: LinkInjectedProps, data: {
        active: boolean;
    }) => React.ReactNode;
};
export type LinkProps = LinkPropsNodeChild | LinkPropsWithFunctionChild;
declare const Link: import("react").ForwardRefExoticComponent<LinkProps & import("react").RefAttributes<any>>;
export default Link;
