"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _useEventCallback = _interopRequireDefault(require("@restart/hooks/useEventCallback"));
var _react = require("react");
var _useRouter = _interopRequireDefault(require("./useRouter"));
var _jsxRuntime = require("react/jsx-runtime");
function _interopRequireDefault(e) { return e && e.__esModule ? e : { default: e }; }
const Link = /*#__PURE__*/(0, _react.forwardRef)(({
  to,
  match: propsMatch,
  router: propsRouter,
  exact = false,
  onClick,
  target,
  children,
  activeClassName,
  activeStyle,
  ...props
}, ref) => {
  const {
    router,
    match
  } = (0, _useRouter.default)() || {
    match: propsMatch,
    router: propsRouter
  };
  const handleClick = (0, _useEventCallback.default)(event => {
    onClick?.(event);

    // Don't do anything if the user's onClick handler prevented default.
    // Otherwise, let the browser handle the link with the computed href if the
    // event wasn't an unmodified left click, or if the link has a target other
    // than _self.
    if (event.defaultPrevented || event.metaKey || event.altKey || event.ctrlKey || event.shiftKey || event.button !== 0 || target && target !== '_self') {
      return;
    }
    event.preventDefault();

    // FIXME: When clicking on a link to the same location in the browser, the
    // actual becomes a replace rather than a push. We may want the same
    // handling – perhaps implemented in the Farce protocol.
    router.push(to);
  });
  const href = router.createHref(to);
  const childrenIsFunction = typeof children === 'function';
  if (childrenIsFunction || activeClassName || activeStyle) {
    const toLocation = router.createLocation(to);
    const active = router.isActive(match, toLocation, {
      exact
    });
    if (childrenIsFunction) {
      return children({
        href,
        onClick: handleClick
      }, {
        active
      });
    }
    const anchorProps = props;
    if (active) {
      if (activeClassName) {
        anchorProps.className = anchorProps.className ? `${anchorProps.className} ${activeClassName}` : activeClassName;
      }
      if (activeStyle) {
        anchorProps.style = {
          ...anchorProps.style,
          ...activeStyle
        };
      }
    }
  }
  return /*#__PURE__*/(0, _jsxRuntime.jsx)("a", {
    ...props,
    href: href,
    ref: ref,
    onClick: handleClick,
    children: children
  });
});
Link.displayName = 'Link';
var _default = exports.default = Link;