import { type Match, type RouteIndices, type RouteMatch, type RouteObjectBase } from './typeUtils';
declare const UNRESOLVED: unique symbol;
export type Unresolved = typeof UNRESOLVED;
/**
 * Detects a resolved Promise by racing a sentinel value with the promise.
 * If the sentinel returns first the promise is still pending.
 *
 * If the value is not a promise it's simply returned
 */
export declare function checkResolved<T extends PromiseLike<any>>(value: T): Promise<Awaited<T> | Unresolved>;
export declare function checkResolved<T>(value: T): T extends PromiseLike<any> ? never : T;
export declare function isResolved<T>(value: T | Unresolved): value is T;
export declare function accumulateRouteValues<TValue = Record<string, unknown>>(routeValues: RouteMatch[], routeIndices: RouteIndices, callback: (...args: any[]) => TValue, initialValue: TValue): TValue[];
export declare function getRouteMatches(match: Match): {
    route: import("./typeUtils").RouteObject;
    routeParams: import("./typeUtils").Params;
    routes: import("./typeUtils").RouteObject[];
    router: import("./typeUtils").Router;
    context: any;
    location: import("farce").Location;
    routeIndices: RouteIndices;
    params: import("./typeUtils").Params;
}[];
export declare function getRouteValue<TResult>(match: RouteMatch, getGetter: (route: RouteObjectBase) => ((match: RouteMatch) => TResult) | undefined, getValue: (route: RouteObjectBase) => TResult): TResult;
export declare function getRouteValues<TResult>(routeMatches: RouteMatch[], getGetter: (route: RouteObjectBase) => ((match: RouteMatch) => TResult) | undefined, getValue: (route: RouteObjectBase) => TResult): TResult[];
export declare function getComponents(routeMatches: RouteMatch[]): (import("react").ComponentType<any> | Promise<import("react").ComponentType<any>> | undefined)[];
export declare function getDatum(routeMatch: RouteMatch): unknown;
export {};
