"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = createInitialFarceRouter;
var _createFarceRouter = _interopRequireDefault(require("./createFarceRouter"));
var _createFarceStore = _interopRequireDefault(require("./createFarceStore"));
var _getStoreRenderArgs = _interopRequireDefault(require("./getStoreRenderArgs"));
var _jsxRuntime = require("react/jsx-runtime");
function _interopRequireDefault(e) { return e && e.__esModule ? e : { default: e }; }
async function createInitialFarceRouter({
  historyProtocol,
  historyMiddlewares,
  historyOptions,
  routeConfig,
  matchContext,
  resolver,
  ...options
}) {
  const store = (0, _createFarceStore.default)({
    historyProtocol,
    historyMiddlewares,
    historyOptions,
    routeConfig
  });
  const FarceRouter = (0, _createFarceRouter.default)({
    ...options,
    store
  });

  // This intentionally doesn't handle RedirectExceptions, because those
  // shouldn't happen here anyway.
  const initialRenderArgs = await (0, _getStoreRenderArgs.default)({
    store,
    matchContext,
    resolver
  });
  function InitialFarceRouter(props) {
    return /*#__PURE__*/(0, _jsxRuntime.jsx)(FarceRouter, {
      ...props,
      initialRenderArgs: props.initialRenderArgs ?? initialRenderArgs,
      matchContext: props.matchContext ?? matchContext,
      resolver: props.resolver ?? resolver
    });
  }
  // We own this FarceRouter, so it's safe to replace its default props.

  return InitialFarceRouter;
}