"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = createRedirect;
var _RedirectException = _interopRequireDefault(require("./RedirectException"));
function _interopRequireDefault(e) { return e && e.__esModule ? e : { default: e }; }
function createRedirect({
  to,
  from,
  status
}) {
  return {
    path: from,
    to,
    status,
    render({
      match
    }) {
      const {
        to,
        status
      } = this;
      let toLocation;
      if (typeof to === 'function') {
        toLocation = to(match);
      } else {
        const {
          router,
          params
        } = match;
        toLocation = router.matcher.format(to, params);
      }
      throw new _RedirectException.default(toLocation, status);
    }
  };
}