"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Route = exports.Redirect = void 0;
exports.makeRouteConfig = makeRouteConfig;
var _react = require("react");
var _createRedirect = _interopRequireDefault(require("./createRedirect"));
function _interopRequireDefault(e) { return e && e.__esModule ? e : { default: e }; }
class Redirect extends _react.Component {
  static isFoundComponent = true;
  static toRoute(props) {
    return (0, _createRedirect.default)(props);
  }
  render() {
    return null;
  }
}
exports.Redirect = Redirect;
class Route extends _react.Component {
  static isFoundComponent = true;
  static toRoute(props) {
    return props;
  }
  render() {
    return null;
  }
}
exports.Route = Route;
// eslint-disable-next-line @typescript-eslint/no-unsafe-function-type
function isFoundComponent(type) {
  return 'isFoundComponent' in type && !!type.isFoundComponent;
}

// TODO: what is even happening in this file? Try to fix as any's(+ maybe simplify)
function buildRouteConfig(node, routeConfig) {
  _react.Children.forEach(node, child => {
    // Falsy children get coerced to null. We check for this instead of
    // implicit falsiness because we don't want to allow empty strings or 0.
    if (child === null) {
      return;
    }
    if (! /*#__PURE__*/(0, _react.isValidElement)(child)) {
      throw new TypeError(`\`${child}\` is not a valid React element`);
    }
    const Type = child.type;
    const {
      children,
      ...props
    } = child.props;
    if (Type === _react.Fragment) {
      buildRouteConfig(children, routeConfig);
      return;
    }
    if (!isFoundComponent(Type)) {
      throw new TypeError(`\`${Type}\` is not a valid found JSX element type`);
    }
    const route = Type.toRoute(props);
    if (children) {
      if (/*#__PURE__*/(0, _react.isValidElement)(children) || Array.isArray(children)) {
        route.children = buildRouteConfig(children, []);
      } else {
        const routeGroups = {};
        Object.entries(children).forEach(([groupName, groupRoutes]) => {
          routeGroups[groupName] = buildRouteConfig(groupRoutes, []);
        });
        route.children = routeGroups;
      }
    }
    routeConfig.push(route);
  });
  return routeConfig;
}

/**
 * Create a route configuration from JSX configuration elements.
 */
function makeRouteConfig(node) {
  return buildRouteConfig(node, []);
}