import RedirectException from './RedirectException';
export default function createRedirect({
  to,
  from,
  status
}) {
  return {
    path: from,
    to,
    status,
    render({
      match
    }) {
      const {
        to,
        status
      } = this;
      let toLocation;
      if (typeof to === 'function') {
        toLocation = to(match);
      } else {
        const {
          router,
          params
        } = match;
        toLocation = router.matcher.format(to, params);
      }
      throw new RedirectException(toLocation, status);
    }
  };
}