import { Children, Component, Fragment, isValidElement } from 'react';
import createRedirect from './createRedirect';
export class Redirect extends Component {
  static isFoundComponent = true;
  static toRoute(props) {
    return createRedirect(props);
  }
  render() {
    return null;
  }
}
export class Route extends Component {
  static isFoundComponent = true;
  static toRoute(props) {
    return props;
  }
  render() {
    return null;
  }
}
// eslint-disable-next-line @typescript-eslint/no-unsafe-function-type
function isFoundComponent(type) {
  return 'isFoundComponent' in type && !!type.isFoundComponent;
}

// TODO: what is even happening in this file? Try to fix as any's(+ maybe simplify)
function buildRouteConfig(node, routeConfig) {
  Children.forEach(node, child => {
    // Falsy children get coerced to null. We check for this instead of
    // implicit falsiness because we don't want to allow empty strings or 0.
    if (child === null) {
      return;
    }
    if (! /*#__PURE__*/isValidElement(child)) {
      throw new TypeError(`\`${child}\` is not a valid React element`);
    }
    const Type = child.type;
    const {
      children,
      ...props
    } = child.props;
    if (Type === Fragment) {
      buildRouteConfig(children, routeConfig);
      return;
    }
    if (!isFoundComponent(Type)) {
      throw new TypeError(`\`${Type}\` is not a valid found JSX element type`);
    }
    const route = Type.toRoute(props);
    if (children) {
      if (/*#__PURE__*/isValidElement(children) || Array.isArray(children)) {
        route.children = buildRouteConfig(children, []);
      } else {
        const routeGroups = {};
        Object.entries(children).forEach(([groupName, groupRoutes]) => {
          routeGroups[groupName] = buildRouteConfig(groupRoutes, []);
        });
        route.children = routeGroups;
      }
    }
    routeConfig.push(route);
  });
  return routeConfig;
}

/**
 * Create a route configuration from JSX configuration elements.
 */
export function makeRouteConfig(node) {
  return buildRouteConfig(node, []);
}