import React from 'react';
import { FarceRouterOptions, RenderArgs, Resolver } from './typeUtils';
interface RouterProviderProps {
    renderArgs: RenderArgs;
    children: React.ReactNode;
}
declare function RouterProvider({ renderArgs, children }: RouterProviderProps): import("react/jsx-runtime").JSX.Element;
export { RouterProvider };
export interface GetFarceResultOptions extends Omit<FarceRouterOptions, 'store' | 'historyProtocol'> {
    url: string;
    resolver?: Resolver;
    matchContext?: any;
}
interface FarceResult {
    status: number;
    element?: any;
    redirect?: any;
}
export declare function getFarceResult({ url, historyMiddlewares, historyOptions, routeConfig, matchContext, resolver, renderPending, renderReady, renderError, render, }: GetFarceResultOptions): Promise<FarceResult>;
