import { forwardRef, useContext } from 'react';
import RouterContext from './RouterContext';
import { jsx as _jsx } from "react/jsx-runtime";
export default function withRouter(Component) {
  const WithRouter = /*#__PURE__*/forwardRef((props, ref) => {
    const context = useContext(RouterContext);
    return /*#__PURE__*/_jsx(Component, {
      ...context,
      ...props,
      ref: ref
    });
  });
  WithRouter.displayName = `withRouter(${Component.displayName || Component.name})`;
  return WithRouter;
}